/*
 * This file is part of BukkitHTTPD.
 * Copyright (C) 2011 "codename_B" Ben Smith <BenBenBen001@googlemail.com>
 * Copyright (C) 2011 Thomas "V10lator" Rohloff <v10lator@myway.de>
 * 
 *
 * BukkitHTTPD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * BukkitHTTPD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BukkitHTTPD.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.V10lator.BukkitHTTPD;

import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerKickEvent;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.event.player.PlayerQuitEvent;

/**
 * 
 * @author V10lator
 *
 */
public class BukkitHTTPDPlayerListener extends PlayerListener
{
  private final BukkitHTTPD plugin;
  
  public BukkitHTTPDPlayerListener(BukkitHTTPD plugin)
  {
	this.plugin = plugin;
  }
  
  public void onPlayerChat(PlayerChatEvent event)
  {
	if(event.isCancelled())
	  return;
	int s = plugin.chatBuffer.length;
	if(s > 19)
	{
	  trimBuffer();
	  s = 19;
	}
	plugin.chatBuffer[s] = (System.currentTimeMillis() / 1000L) + "|" +
			 event.getPlayer().getDisplayName() + ": " +
			 event.getMessage();
  }
  
  public void onPlayerJoin(PlayerJoinEvent event)
  {
	int s = plugin.chatBuffer.length;
	if(s > 19)
	{
	  trimBuffer();
	  s = 19;
	}
	plugin.chatBuffer[s] = (System.currentTimeMillis() / 1000L) + "|" +
			event.getJoinMessage();
  }
  
  public void onPlayerQuit(PlayerQuitEvent event)
  {
	int s = plugin.chatBuffer.length;
	if(s > 19)
	{
	  trimBuffer();
	  s = 19;
	}
	plugin.chatBuffer[s] = (System.currentTimeMillis() / 1000L) + "|" +
			event.getQuitMessage();
  }
  
  public void onPlayerKick(PlayerKickEvent event)
  {
	if(event.isCancelled())
	  return;
	int s = plugin.chatBuffer.length;
	if(s > 19)
	{
	  trimBuffer();
	  s = 19;
	}
	plugin.chatBuffer[s] = (System.currentTimeMillis() / 1000L) + "|" +
			event.getLeaveMessage();
  }
  
  private void trimBuffer()
  {
	String[] tmp = new String[2];
	for(int i = 19; i > -1; i--)
	{
	  tmp[1] = tmp[0];
	  tmp[0] = plugin.chatBuffer[i];
	  plugin.chatBuffer[i] = tmp[1];
	}
  }
}
