/*
 * This file is part of BukkitHTTPD.
 * Copyright (C) 2011 "codename_B" Ben Smith <BenBenBen001@googlemail.com>
 * Copyright (C) 2011 Thomas "V10lator" Rohloff <v10lator@myway.de>
 * 
 *
 * BukkitHTTPD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * BukkitHTTPD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BukkitHTTPD.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.V10lator.BukkitHTTPD;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

import javax.imageio.ImageIO;

//import java.lang.Object;
/**
 * 
 * @author codename_B
 * @author V10lator
 *
 * Replacing DieAnticrash
 */
public class ImageCreator implements Runnable
{
	private final BukkitHTTPD plugin;
	private final Font font = new Font("Arial",Font.PLAIN,12);

    public ImageCreator(BukkitHTTPD plugin)
    {
      this.plugin = plugin;
    }

    public void run()
    {
    	BufferedImage bi = null;
      	try
      	{
      	  bi = ImageIO.read(new File(plugin.wwwDir, "BukkitHTTPD.jpg"));
      	}
      	catch (IOException e)
      	{
      	  e.printStackTrace();
      	  return;
      	}
      	
        while(!plugin.ram.lock.compareAndSet(false, true))
          continue;
        
        ArrayList<String> pl = null;
        if(plugin.ram.showPlugins)
          pl = new ArrayList<String>(plugin.ram.plugins);
        String s = "Players: "+plugin.ram.players.size()+"/"+plugin.ram.maxPlayers;
    	String s2 = "IP: "+plugin.ram.serverHost;
    	Color color = Color.decode("0x"+plugin.ram.color);
    	String h1 = plugin.ram.serverName;
    	plugin.ram.lock.set(false);
    	
    	ArrayList<String> plugins = null;
    	if(pl != null)
    	{
	      Collections.shuffle(pl);
	      plugins = new ArrayList<String>();
	      int pnumber = pl.size();
	      if(pnumber > 12)
	    	pnumber = 12;
	      for(int i = 0; i < pnumber; i++)
	      {
    	    String plugin = pl.get(i);
    	    if(plugin.length() > 15)
    	      plugins.add(plugin.substring(0,15));
    	    else
    		  plugins.add(plugin);
	      }
    	}
    	Graphics g = bi.createGraphics();
		g.setColor(color);//setting font color

		g.setFont(font.deriveFont(Font.BOLD, 20F));
		
		g.drawString(h1,20,25);//Text will be priented 
		
		g.setFont(font.deriveFont(Font.BOLD, 15F));
		
		g.drawString(s,20,45);//Text will be priented
		g.drawString(s2,20,65);//Text will be priented
		if(plugins != null)
		{
		  g.setFont(font);
		  
		  Integer X=300;
		  Integer Y=20;
		  Integer I=0;
		  for(String writeout : plugins)
		  {
			if(I==6)
			{
			  X=430;
			  Y=20;
			}
			g.drawString(writeout,X,Y);
			I++;
			Y=Y+12;
		  }
		}
        try {
        		File o = new File(plugin.wwwDir, "banner.png");
        		if(!o.exists())
        		  o.createNewFile();
                FileOutputStream out = new FileOutputStream(o);
                ImageIO.write(bi, "png", out);
                out.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}

